protobuf-net
-

# What is protobuf-net?

protobuf-net is a .NET library that implements the Protocol Buffers wire format, providing high performance binary reliable cross-platform serialization. It primarily targets a "code first" approach, which contrasts to the schema-first approach more common to Protocol Buffers,
but which makes it really easy to work with idiomatic .NET types, including pre-existing types. protobuf-net now also integrates with protobuf-net.Grpc, to offer a code-first gRPC experience similar to WCF.

## Release Notes

[Change history and pending changes are here](http://protobuf-net.github.io/protobuf-net/releasenotes)

## Other topics

- [Handling `null` values/collections](https://protobuf-net.github.io/protobuf-net/nullwrappers)
- [`CompatibilityLevel`](http://protobuf-net.github.io/protobuf-net/compatibilitylevel)
- [Build Tools for protobuf-net and protobuf-net.Grpc](https://protobuf-net.github.io/protobuf-net/build_tools)
- [Generating code from .proto files at build-time](http://protobuf-net.github.io/protobuf-net/contract_first)
- [Schema analysis tools](http://protobuf-net.github.io/protobuf-net/schemas)
- [Using protobuf-net with Noda Time](http://protobuf-net.github.io/protobuf-net/nodatime)

## Donate

protobuf-net is maintained purely out of my own time - it is not sponsored on an ongoing basis, but if you want to contribute towards the ongoing support, options include:

- [![Buy Me A Coffee](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/marcgravell)
- [GitHub Sponsors](https://github.com/sponsors/mgravell)
- something else in mind? please contact me!
